//----------------------------------------------------------------------
// seqmemread 
// version 1.0
// F. Abignoli
// 4/5/2013
//----------------------------------------------------------------------
// Test de lecture de la memoire de preset du sequenceur
// Lit chaque preset et se contente d'afficher le nom a l'ecran
// Le format affiché doit être PRESET xxx-By
// avec xxx numero de preset de 001 à 128 et y numero de banque de 0 à 1
// Programme prevu pour 24LC256
//----------------------------------------------------------------------


#include <Wire.h> //I2C library
#include <LiquidCrystal_I2C.h>
#if defined(ARDUINO) && ARDUINO >= 100
#define printByte(args)  write(args);
#else
#define printByte(args)  print(args,BYTE);
#endif

LiquidCrystal_I2C lcd(0x27,20,4);       // sLCD adress 0x27, 16 car, 2 lignes



#define MAXPROG 128
#define MAXBANK 2
#define PRESETSIZE  128
#define BANKSIZE  16384

char nompreset[17];   


void eewrite_byte( int deviceaddress, unsigned int eeaddress, byte data ) 
{
int rdata = data;
  Wire.beginTransmission(deviceaddress);
  Wire.write((int)(eeaddress >> 8)); // MSB
  Wire.write((int)(eeaddress & 0xFF)); // LSB
  Wire.write(rdata);
  Wire.endTransmission();
  delay(5);
}

byte eeread_byte( int deviceaddress, unsigned int eeaddress ) {
  byte rdata = 0xFF;
  Wire.beginTransmission(deviceaddress);
  Wire.write((int)(eeaddress >> 8)); // MSB
  Wire.write((int)(eeaddress & 0xFF)); // LSB
  Wire.endTransmission();
  Wire.requestFrom(deviceaddress,1);
  if (Wire.available()) rdata = Wire.read();
    return rdata;
}

void setup() 
{
  //Wire.begin(); // initialise the connection
  lcd.init();             // init du lcd 
  lcd.backlight();        // Retroeclairage
  lcd.clear();            // Effacement de lecran
  lcd.setCursor(0,0);
}

void lire_nompreset(byte mybank,byte mypreset)
{
int i;
int myaddress=0;
char bufnum[4];
int n;
    memset(nompreset,0,sizeof(nompreset));
    
    // Initialisation de l'adresse du preset
    myaddress=(mybank*BANKSIZE)+(mypreset*PRESETSIZE);
    for (i=0;i<16;i++) {
      nompreset[i]=eeread_byte( 0x50, myaddress++);
    }
    
}

void loop() 
{
int addr=0; // adress de debut
int bank;   // Numero de bank
int i,j,k;  // variables de travail
    for (i=0;i<MAXBANK;i++) {
        lcd.clear();
        for (j=0;j<MAXPROG;j++) {
          lire_nompreset(i,j);
          lcd.setCursor(0,0);
          
          lcd.print(i,DEC);
          lcd.print("  ");
          lcd.print(j,DEC);
          lcd.setCursor(0,1);
          lcd.print(nompreset);
          delay(10);
        }
    }
    lcd.setCursor(0,3);
    lcd.print("Fin de lecture");
    while(1) {
    }
    
}